/**************************************************************************

    This file is part of Xclass95, a Win95-looking GUI toolkit.
    Copyright (C) 1996, 1997 David Barth, Hector Peraza.

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free
    Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

**************************************************************************/

#ifndef __OTEXTBUFFER_H
#define __OTEXTBUFFER_H

#include <stdlib.h>
#include <string.h>

#include <X11/Xlib.h>


class OTextBuffer {
public:
  OTextBuffer()
    { _buffer = NULL; _bfrlen = 0; }
  OTextBuffer(unsigned length)
    { _buffer = new char[_bfrlen = length]; *_buffer = '\0'; }
  ~OTextBuffer()
    { if (_buffer) delete[] _buffer; }

  unsigned GetTextLength() const { return strlen(_buffer); }
  unsigned GetBufferLength() const { return _bfrlen; }
  const char *GetString() const { return _buffer; }

  void AddText(int pos, const char *text);
  void AddText(int pos, const char *text, int length);
  void RemoveText(int pos, int length);
  void Clear() { if (_buffer) *_buffer = '\0'; }

protected:
  char *_buffer;
  unsigned _bfrlen;
};

#endif  // __OTEXTBUFFER_H
